/* Sdal-Consgreet

Substitutes keywords with their correct value in consgreet.txt
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#pragma dynamic 4096

new STRING_VERSION[MAX_DATA_LENGTH] = "10.03.02";

#define ACCESS_CONSOLE 131072
#define MAX_COMMANDS 21

new Keywords[MAX_COMMANDS][]=	{{"&ip"},{"&timeleft"},{"&user"},{"&counter"},{"&terror"},{"&bestplayer"},{"&mostfrags"},
				{"&maxplayer"},{"&curplayer"},{"&nextmap"},{"&currentmap"},{"&ff"},{"&chasecam"},{"&gravity"},
				{"&wonid"},{"&hostname"},{"&mp_timelimit"},{"&date"},{"&round"},{"&ctscore"},{"&tscore"}};
				
new Value[MAX_COMMANDS][MAX_TEXT_LENGTH];
				
new ConsText[MAX_TEXT_LENGTH]="addons/adminmod/config/consgreet/constext.txt";

new checktime;
new origtimelimit;

new round=1;
new mostfrags;

public plugin_connect(HLUserName, HLIP ,UserIndex) {
	
	/*Alle Keyword-Variablen ermitteln*/
	convert_string(HLIP,Value[0][0],30);
	/*Zeitermittlung*/
	if (getvar("mp_timelimit")*60+2 != origtimelimit){
        	checktime = systemtime()-(systemtime()- checktime);
        }
        numtostr((origtimelimit-(systemtime()-checktime)),Value[1][0]);
	convert_string(HLUserName,Value[2][0],MAX_NAME_LENGTH);
	numtostr(getteamcount(2),Value[3][0]);
        numtostr(getteamcount(1),Value[4][0]);
        get_playerstats();
        numtostr(maxplayercount(),Value[7][0]);
        numtostr(playercount(),Value[8][0]);
        nextmap(Value[9][0],MAX_NAME_LENGTH);
        currentmap(Value[10][0],MAX_NAME_LENGTH);
        getstrvar("mp_friendlyfire",Value[11][0],MAX_TEXT_LENGTH);
        getstrvar("mp_forcechasecam",Value[12][0],MAX_TEXT_LENGTH);
        getstrvar("sv_gravity",Value[13][0],MAX_TEXT_LENGTH);
        getstrvar("hostname",Value[15][0],MAX_TEXT_LENGTH);
        getstrvar("mp_timelimit",Value[16][0],MAX_TEXT_LENGTH);
        servertime(Value[17][0], MAX_DATA_LENGTH, "%d.%m.%y %H:%M:%S");
        if(strlen(Value[18][0])==0){
		numtostr(1,Value[18][0]);
	}
	if(strlen(Value[19][0])==0){
		numtostr(0,Value[19][0]);
	}
	if(strlen(Value[20][0])==0){
		numtostr(0,Value[20][0]);
	}
	
	new wonid;
        get_userWONID( Value[2][0], wonid);
        numtostr(wonid,Value[14][0]);
                
        /*Funktionsvariablen*/
        new Data[MAX_DATA_LENGTH];
        new iLine;
	new i;
	new j;
			
	/*consgreet.txt einlesen und Keywords vergleichen*/
	iLine=filesize(ConsText);
	
	for(i=1;i<=iLine;i++){
		readfile(ConsText,Data,i,MAX_DATA_LENGTH);
		for(j=0;j<=MAX_COMMANDS;j++){
			strsubst(Data,Keywords[j],Value[j],MAX_DATA_LENGTH);
		}
		consgreet(Data);
	}
	
	return PLUGIN_CONTINUE;
}

get_playerstats(){
	new Player[MAX_NAME_LENGTH];
	new iFrags;
	new i;
	new maxplayers=maxplayercount();

	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			get_userFrags(Player,iFrags);
			if(iFrags>mostfrags){
				strcpy(Value[5][0],Player,MAX_NAME_LENGTH);
				numtostr(iFrags,Value[6][0]);
				mostfrags=iFrags;
			}
		}
	}
	if(strlen(Value[5][0])==0){
		strcpy(Value[5][0],"Niemand",MAX_NAME_LENGTH);
		numtostr(0,Value[6][0]);
	}
	
	return PLUGIN_CONTINUE;
}

public sc_team_action(HLCommand,HLData,HLUserName,UserIndex){
	new Params[MAX_DATA_LENGTH];
	new Data1[MAX_DATA_LENGTH];                                
        new Data2[MAX_DATA_LENGTH];  
	new dummy[MAX_DATA_LENGTH];
	
	convert_string(HLData,Params,MAX_DATA_LENGTH);
	strbreak(Params,Data1,Data2,MAX_DATA_LENGTH);
	strsplit(Data2, "# " ,dummy,MAX_DATA_LENGTH,dummy,MAX_DATA_LENGTH,Value[19][0],MAX_NUMBER_LENGTH,dummy,MAX_DATA_LENGTH,Value[20][0],MAX_NUMBER_LENGTH);

	round++;
	numtostr(round,Value[18][0]);
	
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex){
	new Player[MAX_NAME_LENGTH];
	convert_string(HLUserName,Player,MAX_NAME_LENGTH);
	if(strcmp(Player,Value[5][0])==0){
		mostfrags=0;
	}
	return PLUGIN_CONTINUE;
}

public plugin_init(){
        plugin_registerinfo("Sdal-Consgreet","Make your own consgreet with keywords!",STRING_VERSION);
        plugin_registercmd("sc_team_action", "sc_team_action", ACCESS_CONSOLE);
        exec("logd_reg 61 admin_command sc_team_action");
        checktime =systemtime();
        origtimelimit = getvar("mp_timelimit")*60+2;
        return PLUGIN_CONTINUE;
}